#!/bin/bash

# 
# -----------------------------------------------------------------------------------------
# OSD335x Reference Design Lesson 2 Demo Application
# -----------------------------------------------------------------------------------------
# Copyright 2017-18 Octavo Systems LLC
# Redistribution and use in source and binary forms, with or without modification, 
# are permitted provided that the following conditions are met:
# 1. Redistributions of source code must retain the above copyright notice, this 
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice, 
#    this list of conditions and the following disclaimer in the documentation and/or 
#    other materials provided with the distribution.
# 3. Neither the name of the copyright holder nor the names of its contributors may be
#    used to endorse or promote products derived from this software without specific 
#    prior written permission.
#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
#    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
#    WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
#    IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
#    INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
#    BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
#    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
#    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
#    OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
#    ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# ----------------------------------------------------------------------------------------
# This code can be used on OSD335x Lesson 2 board to detect motion using Motion Click. 
# The LEDs D4 and D5 blink alternatively when motion is detected.
# ----------------------------------------------------------------------------------------



# set GPMC_AD9 pin as input to sense Motion Click interrupt
echo "in" > /sys/class/gpio/gpio23/direction

# set GPMC_A2 and GPMC_AD15 as output
echo "out" > /sys/class/gpio/gpio47/direction
echo "out" > /sys/class/gpio/gpio50/direction

while true
do
	# read status of interrupt pin
	inputVal=$(cat /sys/class/gpio/gpio23/value)

	# check if interrupt pin is high
	if [ "$inputVal" = "1" ];
	then
		# display a message on terminal
		echo "Motion detected"

		# blink LEDs alternatively
		echo "1" > /sys/class/gpio/gpio47/value
		echo "0" > /sys/class/gpio/gpio50/value

		sleep 0.1

		echo "0" > /sys/class/gpio/gpio47/value
		echo "1" > /sys/class/gpio/gpio50/value

		sleep 0.1

	# check if interrupt pin is low
	else
		echo "No motion detected"

		# turn off both LEDs
		echo "0" > /sys/class/gpio/gpio47/value
		echo "0" > /sys/class/gpio/gpio50/value
	fi
done
